﻿using IronPython.Hosting;
using Microsoft.Scripting.Hosting;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;

namespace EmbededPython
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {

        /// <summary>
        /// The runtime
        /// </summary>
        ScriptRuntime runtime = Python.CreateRuntime();
          
        /// <summary>
       /// Initializes a new instance of the <see cref="MainWindow"/> class.
       /// </summary>
        public MainWindow()
        {
            InitializeComponent();
        }

        /// <summary>
        /// Handles the Click event of the StartBtn control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="RoutedEventArgs"/> instance containing the event data.</param>
        private void StartBtn_Click(object sender, RoutedEventArgs e)
        {
            StartProcess(@"E:\Test.py");
        }
      
        private async void StartProcess(string filename)
        {
           await Task.Run(() => ExecuteScript(filename));
        }
       
        /// <summary>
        /// Iron python executes script file
        /// </summary>
        /// <param name="filepath"></param>
        /// <summary>
        /// Iron python executes script file
        /// </summary>
        /// <param name="filepath"></param>
        private void ExecuteScript(string filepath)
        {
            using (var outputStream = new MemoryStream())
            {
                using (var outputWritter = new EventRaisingStreamWriter(outputStream))
                {
                    outputWritter.StringWritten += writeOutput;
                    runtime.IO.SetOutput(outputStream, outputWritter);
                    runtime.ExecuteFile(filepath);
                }
            }
        }
     
        /// <summary>
        /// Writing the obtained output
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void writeOutput(object sender, EvtArgs<string> e)
        {
            var outputValue = e.Value;
                Application.Current.Dispatcher.Invoke(
              DispatcherPriority.Send,
              new Action(
                  delegate()
                  {
                 ResultBox.AppendText(outputValue);
                  }));
        }
    }
}
